package top.ninwoo.dbc.cloud.client.controller;

import org.springframework.stereotype.Controller;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;
import top.ninwoo.dbc.cloud.client.service.FileCloService;

import java.io.FileNotFoundException;
import java.io.IOException;

@Controller
public class FilesController {

    @Autowired
    private FileCloService fileCloService;

    @Value("${dbc.directory.output}")
    private String directoryOutput;

    /*文件上传*/
    // 访问路径为：http://ip:port/upload
    @RequestMapping(value = "/upload",method = RequestMethod.GET)
    public String upload() {
        return "fileUpload";
    }


    @RequestMapping(value = "/upload", method = RequestMethod.POST)
    @ResponseBody
    public String upload(@RequestParam("file") MultipartFile file, @RequestParam("fileId") Long fileId) {
        if (!file.isEmpty()) {
            try {
                byte[] fileBytes = file.getBytes();
                fileCloService.sendFile(fileId,fileBytes);
                /*out.flush();
                out.close();*/
            } catch (FileNotFoundException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            } catch (IOException e) {
                e.printStackTrace();
                return "上传失败," + e.getMessage();
            }
            return "上传成功！";
        } else {
            return "上传失败，因为文件是空的.";
        }
    }


    /*文件下载*/
    //访问路径为：http://ip:port/download?name=x.jpg&fileId=1111
    @RequestMapping("download")
    public String view(String name, Long fileId, Model model) {
        fileCloService.getFile(name, fileId);
        model.addAttribute("fileName", name);
        return "fileDownload";
    }
}
