package top.ninwoo.dbc.cloud.server.controller;

import org.springframework.web.bind.annotation.*;
import top.ninwoo.dbc.api.po.FileCloudSlice;

import java.util.*;

@RestController
public class CloudServerController {
    private static final Map<Long, FileCloudSlice> fileCloudSliceMap = new HashMap<>();

    @GetMapping("/hello/{name}/")
    public String hello(@PathVariable(name = "name") String name) {
        return "Hello " + name;
    }

    @PostMapping("/data/put/")
    public String putData(@RequestBody FileCloudSlice fileCloudSlice) {
        if(fileCloudSlice == null) {
            return "failed";
        }
        if(!fileCloudSliceMap.containsKey(fileCloudSlice.getFileCloudId())) {
            fileCloudSliceMap.put(fileCloudSlice.getFileCloudId(),fileCloudSlice);
        }
        fileCloudSliceMap.put(fileCloudSlice.getFileCloudId(),fileCloudSlice);

        return "success";
    }


    @GetMapping("/data/get/{fileId}")
    public Set<FileCloudSlice> getData(@PathVariable("fileId") Long fileId) {
        try {
            return new HashSet<FileCloudSlice>(fileCloudSliceMap.values());
        } catch (Exception e) {
            throw new RuntimeException("未找到文件");
        }
    }
}
