package top.ninwoo.dbc.server.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import top.ninwoo.dbc.api.po.FileSlice;
import top.ninwoo.dbc.server.FileService;

import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

@RestController
public class ServerController {

/*    @RequestMapping("/hello")
    @ResponseBody
    public String hello(){
        return "hello,springboot";
    }*/
    @Autowired
    private FileService fileService;

    private static final Map<Long, Map<Integer, FileSlice>> fileSliceMap = new HashMap<>();

    @GetMapping("/hello/{name}/")
    public String hello(@PathVariable(name = "name") String name) {
        return "Hello " + name;
    }

    @PostMapping("/data/put/")
    public String putData(@RequestBody FileSlice fileSlice) throws IOException {
        if(fileSlice == null) {
            return "failed";
        }
        if(!fileSliceMap.containsKey(fileSlice.getFileId())) {
            fileSliceMap.put(fileSlice.getFileId(), new HashMap<>());
        }
        Map<Integer, FileSlice> sliceMap = fileSliceMap.get(fileSlice.getFileId());
        sliceMap.put(fileSlice.getSliceId(), fileSlice);

        //完成分散计算
        fileService.fileComputing(fileSlice);
        System.out.println("image gray sucess");
        return "success";
    }

    @GetMapping("/data/get/{fileId}/{sliceId}")
    public FileSlice getData(@PathVariable("fileId") Long fileId, @PathVariable("sliceId") int sliceId) {
        try {
            return fileSliceMap.get(fileId).get(sliceId);

        } catch (Exception e) {
            throw new RuntimeException("未找到对应的文件");
        }
    }

    @GetMapping("/data/get/{fileId}")
    public Set<FileSlice> getData(@PathVariable("fileId") Long fileId) {
        try {
            return new HashSet<FileSlice>(fileSliceMap.get(fileId).values());
        } catch (Exception e) {
            throw new RuntimeException("未找到文件");
        }
    }
}
