package top.ninwoo.dbc.utils;

import top.ninwoo.dbc.api.po.*;
import top.ninwoo.dbc.api.service.DistributedComService;
import org.springframework.stereotype.Service;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

@Service
public class FileServiceImplement implements DistributedComService {


    ImageToArrayUtils itau = new ImageToArrayUtils();
    // 图片切分
    @Override
    public SplitResult fileSplit(BufferedImage bufferedImage, int sliceNum) {

/*        // 读入大图
        BufferedImage image = itau.readImage(srcOrig);*/
        // 分割图片，并将其转化为byte数组
        List<byte[]> byteList  = itau.imageSplit(bufferedImage,sliceNum);

        List<FileSlice> fileSliceList = new ArrayList<>();
        for (int i = 0; i < byteList.size(); i++) {
            FileSlice fileSlice = new FileSlice();
            fileSlice.setFileId(1L);//文件的唯一标识
            fileSlice.setSliceId(i);//数据碎片的id
            fileSlice.setFileBytes(byteList.get(i));//文件的比特数据
            fileSliceList.add(fileSlice);
        }
        SplitResult splitResult = new SplitResult();
        splitResult.setFileSliceList(fileSliceList);
        return splitResult;
    }

    //小图片处理---灰度处理
    @Override
    public ComputingResult sliceComputing(SplitResult splitResult){

        List<FileSlice> fileSliceList = splitResult.getFileSliceList();
        List<byte[]> grayByteList = itau.grayImage(fileSliceList);
        //把每个小图片转为一个byte数组
        //List<byte[]> grayByteList = itau.imageToByte(grayImage);
        List<FileSliceComputing> grayfileSliceList = new ArrayList<>();
        for (int i = 0; i < grayByteList.size(); i++) {
            FileSliceComputing fileSliceComputing = new FileSliceComputing();
            fileSliceComputing.setFileId(1L);//文件的唯一标识
            fileSliceComputing.setSliceId(i);//数据碎片的id
            fileSliceComputing.setFileBytes(grayByteList.get(i));//文件的比特数据
            grayfileSliceList.add(fileSliceComputing);
        }
        ComputingResult computingResult = new ComputingResult();
        computingResult.setFileSliceComputingList(grayfileSliceList);
        return computingResult;
    }

    @Override
    public MergeResult sliceMerge(ComputingResult computingResult,int sliceNum) {
        List<FileSliceComputing> grayfileSliceList = computingResult.getFileSliceComputingList();
        BufferedImage finalImg = itau.imageMerge(grayfileSliceList, sliceNum);

        MergeResult mergeResult = new MergeResult();
        mergeResult.setImages(finalImg);
        return mergeResult;
    }

    public SendResult sendFileSlice(String targetIp, FileSlice fileSlice) {
        return null;
    }

    public FileSlice getFileSlice(String targetIp, Long fileId, int sliceId) {
        return null;
    }


    //地面云计算处理图片
    @Override
    public CloudComputingResult fileComputing(SendResult sendResult){

        List<FileCloudSlice> fileCloudSliceList = sendResult.getFileCloudSliceList();
        FileCloudSlice fileCloudSlice = fileCloudSliceList.get(0);
        byte[] bytes = fileCloudSlice.getFileByte();

        //1、byte[]转为BufferedImage
        ByteArrayInputStream bis = new  ByteArrayInputStream(bytes);
        BufferedImage image = null;
        try {
            image = ImageIO.read(bis);
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            bis.close();
        } catch (IOException e) {
            e.printStackTrace();
        }

        //2、BufferedImage进行灰度化处理
        int width = image.getWidth();
        int height = image.getHeight();
        BufferedImage grayImage = new BufferedImage(width, height, BufferedImage.TYPE_BYTE_GRAY);//重点，技巧在这个参数BufferedImage.TYPE_BYTE_GRAY
        for(int i= 0 ; i < width ; i++){
            for(int j = 0 ; j < height; j++){
                int rgb = image.getRGB(i, j);
                grayImage.setRGB(i, j, rgb);
            }
        }

        //3、灰度化处理后的BufferedImage转为byte[]
        ByteArrayOutputStream bos = new ByteArrayOutputStream();
        try {
            ImageIO.write(grayImage,"jpg",bos);
        } catch (IOException e) {
            e.printStackTrace();
        }
        try {
            bos.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
        byte[] fileComBytes = bos.toByteArray();

        CloudComputingResult cloudComputingResult = new CloudComputingResult();
        cloudComputingResult.setFileComBytes(fileComBytes);
        return cloudComputingResult;
    }


}
