package top.ninwoo.weixingsim.dynamicNet;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.HashMap;

import static top.ninwoo.weixingsim.dynamicNet.CycleTopoUnit.cycleTp;

public class TimeExpanGraph {

    /*
     * 网络参数
     */
    //设备数
    static int num = 30;

    //时隙大小
    static double slot = 20*1000;
    //时隙数目
    static int slotnum;
    //网络节点数
    static int dev;


    public static void main(String[] args) {
        doMapApp();
    }

    //业务发起时刻
    public static long startT;

    public static void doMapApp() {


        for (slotnum = 1;slotnum<=3;slotnum++) {

            dev = num * slotnum;//10个卫星节点，3个时隙，则共有10*3个卫星节点
            //组装最短路矩阵
            int[][] matrixGraph = MatrixGraph();
            System.out.println("大矩阵是：");
            for (int i = 0; i < matrixGraph.length; i++) {
                for (int j = 0; j < matrixGraph[0].length; j++) {
                    System.out.print(matrixGraph[i][j]+"    ");
                }
                System.out.println();
            }

            //最短路由矩阵

        }
    }

    private static int[][] MatrixGraph() {

        //获取当前3时隙拓扑
        /**
         * 先用SimpleDateFormat.parse() 方法将日期字符串转化为Date格式
         * 通过Date.getTime()方法，将其转化为毫秒数
         */
        String date = "2019-01-01 00-00-00";
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");//24小时制
        long time = 0;
        try {
            time = simpleDateFormat.parse(date).getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        int slotKey = (int) ((((System.currentTimeMillis()-time)/20/1000)-1)%300+1);
        startT= ((System.currentTimeMillis()-time)/20000+1)*20000;

        HashMap<Integer,int[][]> cycleTp = cycleTp();

        //获得第1个时隙的连接矩阵  0或1
        int[][] currentTp = cycleTp.get((slotKey)%30+1);
        int[][] slot1 = new int[num][num]; //10*10的矩阵图
        for(int i = 0;i<slot1.length;i++){
            for(int j = 0;j<slot1[0].length;j++){
                slot1[i][j] = currentTp[i][j];
            }
        }
        /*for(int i = 0;i<slot1.length;i++){
            for(int j = 0;j<slot1[0].length;j++){
                if (currentTp[i][j]==0){
                    if (i==j){
                        slot1[i][j]=0;
                    }else
                        slot1[i][j] = 0;
                }else{
                    slot1[i][j] = currentTp[i][j];
                }

            }
        }*/

        //获得第2个时隙的连接矩阵
        currentTp = cycleTp.get((slotKey)%30+2);
        int[][] slot2 = new int[num][num];
        for(int i = 0;i<slot2.length;i++){
            for(int j = 0;j<slot2.length;j++){
                if (currentTp[i][j]==0){
                    if (i==j){
                        slot2[i][j]=0;
                    }else
                        slot2[i][j] = 0;
                }else {
                    slot2[i][j] = currentTp[i][j];
                }
            }
        }

        //获得第3个时隙的连接矩阵
        currentTp = cycleTp.get((slotKey)%30+3);
        int[][] slot3 = new int[num][num];
        for(int i = 0;i<slot3.length;i++){
            for(int j = 0;j<slot3.length;j++){
                if (currentTp[i][j]==0){
                    if (i==j){
                        slot3[i][j]=0;
                    }else
                        slot3[i][j] = 0;
                }else {
                    slot3[i][j] = currentTp[i][j];
                }
            }
        }
        //生成相邻时隙矩阵
        int[][] neighbor = new int[num][num];
        for(int i = 0;i<neighbor.length;i++){
            for(int j = 0;j<neighbor.length;j++){
                if(i == j){
                    neighbor[i][j] = 1;
                }else{
                    neighbor[i][j] = 0;
                }
            }
        }
        //生成其余时隙矩阵
        int[][] nonNeighbor = new int[num][num];
        for(int i = 0;i<nonNeighbor.length;i++){
            for(int j = 0;j<nonNeighbor.length;j++){
                nonNeighbor[i][j] = 0;
            }
        }
        //组装连接矩阵
        int[][] edgeWeight = new int[dev][dev];
        for(int i = 0;i<edgeWeight.length;i++){
            for(int j = 0;j<edgeWeight[0].length;j++){
                if (i>=0 & i<num & j>=0 & j<num) {
                    edgeWeight[i][j] = slot1[i][j];
                }else if (i>=num & i<2*num & j>=num & j<2*num) {
                    edgeWeight[i][j] = slot2[i%num][j%num];
                }else if (i>=2*num & i<3*num & j>=2*num & j<3*num) {
                    edgeWeight[i][j] = slot3[i%num][j%num];
                }else if ((i>=0 & i<num & j>=num & j<2*num) || (i>=num & i<2*num & j>=2*num & j<3*num)){
                    edgeWeight[i][j] = neighbor[i%num][j%num];
                }else {
                    edgeWeight[i][j] = nonNeighbor[i%num][j%num];
                }

            }
        }
        return edgeWeight;
    }
}
