package top.ninwoo.app.dfs.client.config;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.http.client.ClientHttpRequestFactory;
import org.springframework.http.client.SimpleClientHttpRequestFactory;
import org.springframework.web.client.RestTemplate;
import top.ninwoo.app.dfs.service.FileTransferServiceImpl;
import top.ninwoo.commonapi.service.TransferService;

@Configuration
public class MainConfig {

    @Primary
    @Bean(name="fileRestTemplate")
    public RestTemplate restTemplate(ClientHttpRequestFactory factory){
        return new RestTemplate(factory);
    }

    @Bean
    public ClientHttpRequestFactory simpleClientHttpRequestFactory(){
        SimpleClientHttpRequestFactory factory = new SimpleClientHttpRequestFactory();
        factory.setReadTimeout(20000);//单位为ms
        factory.setConnectTimeout(20000);//单位为ms
        return factory;
    }

    @Bean
    public TransferService transferService() {
        return new FileTransferServiceImpl();
    }
}
