package top.ninwoo.weixingsim.dynamicNet;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.HashMap;

import static top.ninwoo.weixingsim.dynamicNet.CycleTopoUnit.cycleTp;

public class SingleSlotTopology {

    /*
     * 网络参数
     */
    //设备数
    static int num = 30;

    //时隙大小
    static double slot = 20*1000;
    //时隙数目
    static int slotnum;
    //网络节点数
    static int dev;


    public static void main(String[] args) {
       int[][] matrixGraph =  SingleMatrixGraph();
        for (int i = 0; i < matrixGraph.length; i++) {
            for (int j = 0; j < matrixGraph[0].length; j++) {
                System.out.print(matrixGraph[i][j]+"    ");
            }
            System.out.println();
        }
    }

    //业务发起时刻
    public static long startT;


    private static int[][] SingleMatrixGraph() {

        //获取当前3时隙拓扑
        /**
         * 先用SimpleDateFormat.parse() 方法将日期字符串转化为Date格式
         * 通过Date.getTime()方法，将其转化为毫秒数
         */
        String date = "2019-01-01 00-00-00";
        SimpleDateFormat simpleDateFormat = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");//24小时制
        long time = 0;
        try {
            time = simpleDateFormat.parse(date).getTime();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        int slotKey = (int) ((((System.currentTimeMillis()-time)/20/1000)-1)%300+1);
        startT= ((System.currentTimeMillis()-time)/20000+1)*20000;

        HashMap<Integer,int[][]> cycleTp = cycleTp();

        //获得第1个时隙的连接矩阵  0或1
        int[][] currentTp = cycleTp.get((slotKey)%30+1);
        int[][] slot1 = new int[num][num]; //10*10的矩阵图
        for(int i = 0;i<slot1.length;i++){
            for(int j = 0;j<slot1[0].length;j++){
                slot1[i][j] = currentTp[i][j];
            }
        }

        return slot1;
    }
}
