package top.ninwoo.weixingsim.sateTopology.init;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;
import top.ninwoo.bishe.starter.service.ClusterService;
import top.ninwoo.common.entity.*;
import top.ninwoo.weixingsim.sateTopology.entity.SimData;
import top.ninwoo.weixingsim.sateTopology.entity.WeiXingData;
import top.ninwoo.weixingsim.sateTopology.service.impl.ToponetImpl;
import top.ninwoo.weixingsim.sateTopology.service.impl.WeixingImpl;

import java.io.File;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;


public class Initapp implements CommandLineRunner {

    @Autowired
    private ClusterService clusterService;

    @Override
    public void run(String... args) throws Exception {
        ArrayList<SeparatedClusterConfig> clusterConfigs = new ArrayList<>();
        SeparatedClusterConfig separatedClusterConfig = new SeparatedClusterConfig();
        List<ContainerDescription> cds = new ArrayList<>();
        // TODO: 这个ID应该是从借口获取的
        separatedClusterConfig.setEdgeNodeId("192.168.31.198:18088");
        ClusterConfig clusterConfig = new ClusterConfig();
        clusterConfig.setId(11111L);
        clusterConfig.setOwner("joliu");

        //从文本中获取卫星的数据
        WeixingImpl wx = new WeixingImpl();
        ToponetImpl tp = new ToponetImpl();
        SimData sd = new SimData();
        //tp.delHistory();
        File file = new File("D:\\LabratoryJavaPro\\codingDownload\\latestCoding\\topusim_1.txt");

        List<WeiXingData> wxData = wx.iniTopo(file,sd.getZhouqi());
        int[][] toponet = tp.getTopology(wxData,sd);


        //创建容器
        for (int k = 0; k < wxData.size(); k++) {
            ContainerDescription containerDescription = new ContainerDescription();
            containerDescription.setMode("normal");
            containerDescription.setReplicas(1);

            DockerContainer container = new DockerContainer();
            container.setName(wxData.get(k).getName());
            container.setCommand("sh");
            container.setImage("joliu/networktest");

            containerDescription.setDockerContainer(container);
            cds.add(containerDescription);
        }

        //设置创建时间
        //自己设计的时间
        //sd.setDefaultDate("2020-07-16 20-38-56");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH-mm-ss");//24小时制
        clusterConfig.setCreateTime(sdf.parse(sd.getDefaultDate()));
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        clusterConfig.setDockers(cds);
        NetworkTopology topo = new NetworkTopology();
        topo.setAppNames(tp.getAppNames(wxData));
        // 这个参数好像没啥用
        topo.setTopologyId(11);
        topo.setTopology(toponet);
        clusterConfig.setTopology(topo);
        separatedClusterConfig.setClusterConfig(clusterConfig);
        clusterConfigs.add(separatedClusterConfig);

        clusterService.sendClusterConfigToEdgeNode(clusterConfigs);

        //下发逻辑拓扑
        clusterService.sendLogicTopoToEdgeNode(clusterConfigs);

        out:for (int i = 1; i<600; i++) {
            Thread.sleep(2000);
            int time = i * sd.getJiange();
            List<WeiXingData> changetp = wx.changeTopo(wxData,time);

            topo.setTopology(tp.getTopology(changetp,sd));

            //下发修改后逻辑拓扑
            clusterService.adjustLogicTopoToEdgeNode(clusterConfigs);
            Boolean tag = false;

            for(int k=1;k<toponet[0].length;k++){
                for (int j=0;j<k;j++){
                    if(toponet[k][j] == tp.getTopology(changetp, sd)[k][j]){
                        tag = true;
                    }
                }
            }
            if(tag){
                break out;
            }
        }

        System.out.println("所有topo完成");
    }

}
